*!Ŀ
*!                     NG KHAI DEVELOPMENT CORP.                       
*!             Computer Consultancy * Software Development             
*! 						       Import * Export                      
*!           FAX : 63-32-86241       73751.1012@Compuserve.com         
*!		               Hernan Cortes St., Banilad                       
*!                        Mandaue City, Cebu                           
*!                         6014 Philippines                            
**Ĵ
*!                                                                     
*!  AUTHOR       : Ronaldo M. Sering                                   
*!  DATE 		   : March 19, 1994                                     
*!  DESCRIPTION  : This program provides a variety of backup utitities 
*!                 for users.                                          
*!                                                                     
*!  MODIFICATION LOG :                                                 
*!                                                                     
*!      WHO  :                                                         
*!      WHEN :                                                         
*!      WHY  :                                                         
*!                                                                     
*!
SET CONFIRM ON
SET EXCLUSIVE ON
SET TALK OFF
*
* Determine if database information about 
* drive, path destination for backup files
* exist. If not create new one.
*
IF FILE("BAREDIR.DBF")
	IF USED('baredir')
		SELECT baredir
	ELSE
		SELECT 0
		USE baredir
	ENDIF	
ELSE
	= DIALOG("Drive/Path information for backup files not found.;New drive/path information will be created.",7,"\<OK   ")
	SELECT 0
	CREATE TABLE BAREDIR.DBF;
		( Monday    C(60) ,;
		  Tuesday   C(60) ,;
		  Wednesday C(60) ,;
		  Thursday  C(60) ,;
		  Friday    C(60) ,;
		  Saturday  C(60))
	DO WHILE NOT FLOCK()
	ENDDO
	APPEND BLANK
	REPLACE Monday    WITH "A:\"
	REPLACE Tuesday   WITH "B:\"
	REPLACE Wednesday WITH "C:\"
	REPLACE Thursday  WITH "D:\"
	REPLACE Friday    WITH "E:\"
	REPLACE Saturday  WITH "F:\"
	UNLOCK IN baredir
ENDIF		

*
* Determine if backup information exist.
* If not create a new one.
*
IF FILE("BACKUP.DBF")
	IF USED('backup')
		SELECT backup
		SET ORDER TO TAG "backtday"
	ELSE
		SELECT 0
		USE backup ORDER TAG "backtday"
	ENDIF
ELSE
	=DIALOG("Backup files information not found.;New backup files info will be created.",7,"\<OK    ")
	SELECT 0
	CREATE TABLE BACKUP.DBF ;
		( BackType C(10) ,;
		  BackDay  N(1)  ,;
		  BackDate D)
	INDEX ON BackType+STR(BackDay) TAG "backtday" ADDITIVE
ENDIF

SET PROCEDURE TO TOOLS

*       ķ
*                                                                
*                           Window definitions                   
*                                                                
*       Ľ
IF NOT WEXIST("backupwin")
	DEFINE WINDOW backupwin ;
		FROM INT((SROW()-24)/2),INT((SCOL()-60)/2) ;
		TO INT((SROW()-24)/2)+24,INT((SCOL()-60)/2)+59 ;
		TITLE "[ BACKUP WINDOW ]" ;
		FLOAT ;
		CLOSE ;
		SHADOW ;
		MINIMIZE ;
		ZOOM ;
		GROW ;
		SYSTEM ;
		COLOR SCHEME 1
ENDIF
*       ķ
*                                                                
*                        BACKCOPY Screen Layout                  
*                                                                
*       Ľ
IF WVISIBLE("backupwin")
	ACTIVATE WINDOW backupwin SAME
ELSE
	ACTIVATE WINDOW backupwin NOSHOW
ENDIF

@ 3,5 SAY "COMMAND :"
@ 10,3 TO 17,20
@ 10,21 TO 17,54
@ 9,2 TO 18,55
@ 9,4 SAY "[ DAILY DESTINATION DRIVE\PATHS ]"
@ 1,2 TO 8,55
@ 1,4 SAY "[ BACKUP TYPE ]"
@ 5,3 TO 7,54
@ 2,3 TO 4,54
@ 19,2 TO 21,55
@ 19,4 SAY "[ ACTION ]"

m.BackType = SPACE(10)					&& Backup type {COMMAND, BACKUP, COPY, PKZIP}
m.BackDay  = 0								&& Day backup was made
m.CurDir   = SYS(5)+CURDIR()			&& Current directory
m.Dest     = ""							&& Destination of backup

SELECT baredir
SCATTER MEMVAR

@ 3,15 GET m.ComLine ;
	SIZE 1,38 ;
	DEFAULT " " ;
	PICTURE "@!K" ;
	WHEN _WDayBackup() ;
	VALID _VCommandLine()
@ 6,7 GET m.BackUpType ;
	PICTURE "@*RHN \<Backup;\<Copy;\<Pkzip" ;
	SIZE 1,15,0 ;
	DEFAULT 1 ;
	VALID _VBackUpType()
@ 11,5 GET m.DayBackup ;
	PICTURE "@*RVN \<Monday;\<Tuesday;\<Wednesday;T\<hursday;\<Friday;\<Saturday" ;
	SIZE 1,13,0 ;
	DEFAULT 1 ;
	WHEN _WDayBackup() ;
	VALID _VDayBackup()
@ 11,23 GET m.Monday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 12,23 GET m.Tuesday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 13,23 GET m.Wednesday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 14,23 GET m.Thursday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 15,23 GET m.Friday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 16,23 GET m.Saturday ;
	SIZE 1,30 ;
	DEFAULT " " ;
	WHEN _WDayBackup() ;
	PICTURE "@!K"
@ 20,5 GET m.BackEvent ;
	PICTURE "@*HN sa\<Ve Setup;backup \<Now;\<Exit" ;
	SIZE 1,14,3 ;
	DEFAULT 1 ;
	VALID _VBackEvent()

IF NOT WVISIBLE("backupwin")
	ACTIVATE WINDOW backupwin
ENDIF

READ CYCLE DEACTIVATE _VWClose("backupwin")

RELEASE WINDOW backupwin
CLOSE DATA
SET EXCLUSIVE OFF
RETURN
*!Ŀ
*!                  VALIDATE COMMAND LINE                     
*!
FUNCTION _VCommandLine
*begin
	IF NOT EMPTY(m.ComLine)
		SHOW GET m.BackUpType DISABLE
		SHOW GET m.DayBackup  DISABLE
		SHOW GET m.Monday     DISABLE
		SHOW GET m.Tuesday    DISABLE
		SHOW GET m.Wednesday  DISABLE
		SHOW GET m.Thursday   DISABLE
		SHOW GET m.Friday     DISABLE
		SHOW GET m.Saturday   DISABLE
	ELSE	
		SHOW GET m.BackUpType ENABLE
		SHOW GET m.DayBackup  ENABLE
		=_WDayBackup()
		DO CASE
			CASE m.DayBackup = 1			&& Monday
				SHOW GET m.Monday ENABLE
			CASE m.DayBackup = 2			&& Tuesday
				SHOW GET m.Tuesday ENABLE
			CASE m.DayBackup = 3			&& Wednesday
				SHOW GET m.Wednesday ENABLE
			CASE m.DayBackup = 4			&& Thursday
				SHOW GET m.Thursday ENABLE
			CASE m.DayBackup = 5			&& Friday	
				SHOW GET m.Friday ENABLE
			CASE m.DayBackup = 6			&& Saturday
				SHOW GET m.Saturday ENABLE
		ENDCASE
	ENDIF
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _VBackUpType
*begin
	_CUROBJ = OBJNUM(m.DayBackup)
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _WDayBackup
*begin
	DO CASE
		CASE m.DayBackup = 1 			&& Monday
			SHOW GET m.Tuesday    DISABLE
			SHOW GET m.Wednesday  DISABLE
			SHOW GET m.Thursday   DISABLE
			SHOW GET m.Friday     DISABLE
			SHOW GET m.Saturday   DISABLE
		CASE m.DayBackup = 2 			&& Tuesday
			SHOW GET m.Monday     DISABLE
			SHOW GET m.Wednesday  DISABLE
			SHOW GET m.Thursday   DISABLE
			SHOW GET m.Friday     DISABLE
			SHOW GET m.Saturday   DISABLE
		CASE m.DayBackup = 3 			&& Wednesday
			SHOW GET m.Monday     DISABLE
			SHOW GET m.Tuesday    DISABLE
			SHOW GET m.Thursday   DISABLE
			SHOW GET m.Friday     DISABLE
			SHOW GET m.Saturday   DISABLE
		CASE m.DayBackup = 4 			&& Thursday
			SHOW GET m.Monday     DISABLE
			SHOW GET m.Tuesday    DISABLE
			SHOW GET m.Wednesday  DISABLE
			SHOW GET m.Friday     DISABLE
			SHOW GET m.Saturday   DISABLE
		CASE m.DayBackup = 5 			&& Friday
			SHOW GET m.Monday     DISABLE
			SHOW GET m.Tuesday    DISABLE
			SHOW GET m.Wednesday  DISABLE
			SHOW GET m.Thursday   DISABLE
			SHOW GET m.Saturday   DISABLE
		CASE m.DayBackup = 6 			&& Saturday
			SHOW GET m.Monday     DISABLE
			SHOW GET m.Tuesday    DISABLE
			SHOW GET m.Wednesday  DISABLE
			SHOW GET m.Thursday   DISABLE
			SHOW GET m.Friday     DISABLE
	ENDCASE
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _VDayBackup
*begin
	=_WDayBackup()
	DO CASE
		CASE m.DayBackup = 1			&& Monday
			SHOW GET m.Monday ENABLE
			_CUROBJ = OBJNUM(m.Monday)
		CASE m.DayBackup = 2			&& Tuesday
			SHOW GET m.Tuesday ENABLE
			_CUROBJ = OBJNUM(m.Tuesday)
		CASE m.DayBackup = 3			&& Wednesday
			SHOW GET m.Wednesday ENABLE
			_CUROBJ = OBJNUM(m.Wednesday)
		CASE m.DayBackup = 4			&& Thursday
			SHOW GET m.Thursday ENABLE
			_CUROBJ = OBJNUM(m.Thursday)
		CASE m.DayBackup = 5			&& Friday	
			SHOW GET m.Friday ENABLE
			_CUROBJ = OBJNUM(m.Friday)
		CASE m.DayBackup = 6			&& Saturday
			SHOW GET m.Saturday ENABLE
			_CUROBJ = OBJNUM(m.Saturday)
	ENDCASE
	RETURN .T.
*end
*!Ŀ
*!                                                            
*!
FUNCTION _VBackEvent
*begin
	IF NOT EMPTY(m.ComLine)
		m.BackType = "COMMAND"
	ELSE	
		DO CASE
			CASE m.BackUpType = 1
				m.BackType = "BACKUP"
			CASE m.BackUpType = 2
				m.BackType = "COPY"
			CASE m.BackUpType = 3
				m.BackType = "PKZIP"
		ENDCASE
	ENDIF
	m.BackDay = m.DayBackUp
	DO CASE 
		CASE m.BackEvent = 1				&& 	Save Setup
			DO SaveSetUp
		CASE m.BackEvent = 2				&&    Start Backup Process
			DO BackItUp
		CASE m.BackEvent = 3				&&		Quit Backup	
			CLEAR READ
	ENDCASE
	RETURN 0
*end
*!Ŀ
*!                                                            
*!
PROCEDURE SaveSetUp
*begin
	=ACTTHERM("SAVING SETUP...")
	IF USED('baredir')
		SELECT baredir
	ELSE
		SELECT 0
		USE baredir
	ENDIF	
	=UPDTHERM(45,"")
	DO WHILE NOT RLOCK()
	ENDDO
	REPLACE Monday    WITH m.Monday
	REPLACE Tuesday   WITH m.Tuesday
	REPLACE Wednesday WITH m.Wednesday
	REPLACE Thursday  WITH m.Thursday
	REPLACE Friday    WITH m.Friday
	REPLACE Saturday  WITH m.Saturday
	=UPDTHERM(80,"")
	UNLOCK IN baredir
	=UPDTHERM(100,"")
	=DEACTTHERM()
	WAIT WINDOW NOWAIT "Saving of setup completed."
*end
*!Ŀ
*!                                                            
*!
PROCEDURE BackItUp
*begin
	DO CASE
		CASE m.DayBackup = 1
			m.Dest = m.Monday
		CASE m.DayBackup = 2
			m.Dest = m.Tuesday
		CASE m.DayBackup = 3
			m.Dest = m.Wednesday
		CASE m.DayBackup = 4
			m.Dest = m.Thursday
		CASE m.DayBackup = 5
			m.Dest = m.Friday
		CASE m.DayBackup = 6
			m.Dest = m.Saturday
	ENDCASE
	
	m.Dest = ALLT(m.Dest)
	
	IF DIREXIST(ADDBS(m.Dest))	
		DO CASE
			CASE m.BackType = "COMMAND"
				DO UPDATEFILE
				CLOSE DATABASES			&& Close open database files so that access to these files
												&& will not be denied.
				RUN &ComLine
			CASE m.BackType = "BACKUP"
				m.CurDir = m.CurDir
				m.Dest   = ALLT(LEFT(m.Dest,2))
				mess = "Make sure that BACKUP.EXE exist in correct path.;"
				mess = mess + "NOTE : Valid destinations are only drive. Paths will be truncated."
				IF DIALOG(mess,7,"\!\<OK ; \<Cancel") = 1
					DO UPDATEFILE
					CLOSE DATABASES			&& Close open database files so that access to these files
													&& will not be denied.
					pcCommand = "RUN BACKUP "+m.CurDir+"*.DBF "+m.Dest+" /L"
					&pcCommand
					pcCommand = "RUN BACKUP "+m.CurDir+"*.CDX "+m.Dest+" /A /L"
					&pcCommand
					pcCommand = "RUN BACKUP "+m.CurDir+"*.FPT "+m.Dest+" /A /L"
					&pcCommand
				ENDIF	
			CASE m.BackType = "COPY"
				m.CurDir = UPPER(m.CurDir)
				m.Dest   = ALLT(m.Dest)
				IF ALLT(m.CurDir) = UPPER(m.Dest)
					= DIALOG("Cannot do backup to the same drive and path.",7,"\<OK")
					RETURN 0
				ENDIF
				IF LEFT(m.Dest,1) $ "AB"
					= DIALOG("Cannot do backup to that drive. Please use other BACKUP utility.",7,"\<OK")
				ELSE	
					DO UPDATEFILE
					CLOSE DATABASES			&& Close open database files so that access to these files
													&& will not be denied.
					DO COPYFILENOW
				ENDIF	
			CASE m.BackType = "PKZIP"
				m.CurDir = m.CurDir
				m.Dest   = ADDBS(ALLT(m.Dest))+ "BACKUP01"
				mess = "Make sure that PKZIP.EXE exist in correct path."
				IF DIALOG(mess,7,"\!\<OK ; \<Cancel") = 1
					DO UPDATEFILE
					CLOSE DATABASES			&& Close open database files so that access to these files
													&& will not be denied.
					pcCommand = "RUN PKZIP "+m.Dest+" "+m.Curdir+"*.DBF"
					&pcCommand
					pcCommand = "RUN PKZIP "+m.Dest+" "+m.Curdir+"*.CDX -A"
					&pcCommand
					pcCommand = "RUN PKZIP "+m.Dest+" "+m.Curdir+"*.FPT -A"
					&pcCommand
				ENDIF	
		ENDCASE
	ELSE
		=DIALOG("Directory/Path does not exist.;Cannot do BACKUP.",7,"\<OK")
		RETURN 0
	ENDIF	
*end
*!Ŀ
*!                                                            
*!
PROCEDURE COPYFILENOW
*begin
*
* Get all necessary file to be backed up
* using the copyfile user defined function(udf).
*

DIMENSION pcDBFfiles(1)
DIMENSION pcCDXfiles(1)
DIMENSION pcFPTfiles(1)

= ADIR( pcDBFfiles, m.CurDir + "*.DBF")		&& Get all database files

IF TYPE("pcDBFfiles") = "L"						&& No files found
	RETURN												&& return to calling program
ENDIF

= ADIR( pcCDXfiles, m.CurDir + "*.CDX")		&& Get all index files
= ADIR( pcFPTfiles, m.CurDir + "*.FPT")		&& Get all memo files
*
* Determine the total number of files to be backed up.
*
pnTotDBF = ALEN(pcDBFfiles,1)			&& Total DBF files
pnTotCDX = ALEN(pcCDXfiles,1)			&& Total CDX files
pnTotFPT = ALEN(pcFPTfiles,1)			&& Total FPT files
*
* Determine the total size of all files to be backed up.
*
pnTotSize = 0								&& Total size of all DBF files
FOR I = 1 TO pnTotDBF
	pnTotSize = pnTotSize + pcDBFfiles[I,2]
ENDFOR

IF NOT TYPE("pcCDXfiles") = "L"		&& If CDX files are found get the total size of all
	FOR I = 1 TO pnTotCDX
		pnTotSize = pnTotSize + pcCDXfiles[I,2]
	ENDFOR	
ELSE
	pnTotCDX = 0	
ENDIF

IF NOT TYPE("pcFPTfiles") = "L"		&& If FPT files are found get the total size of all
	FOR I = 1 TO pnTotFPT
		pnTotSize = pnTotSize + pcFPTfiles[I,2]
	ENDFOR
ELSE
	pnTotFPT = 0	
ENDIF

=ACTTHERM("")				&& activate thermometer

pnCurPercent = 0			&& Percent finished

mess = "Copying TABLES : "+pcDBFfiles[1,1]+" TO "+m.Dest+pcDBFfiles[1,1]
= UPDTHERM(2,mess)

plOverWAll = .F.				&& Overwrite all files already exist.
plIgnorAll = .F.				&& Ignore all error encountered while copying.
PlCancel   = .F.           && User interrupted or cancelled operation.

FOR I = 1 TO pnTotDBF

	mess = "Copying TABLES : "+pcDBFfiles[I,1]+" TO "+m.Dest+pcDBFfiles[I,1]
	pnCurPercent = pnCurPercent + ((pcDBFfiles[I,2]/pnTotSize)*100)
   pnExist = 0
	
	IF NOT plOverWAll   
		IF FILE(m.Dest+pcDBFfiles[I,1])
			pnExist = DIALOG(pcDBFfiles[I,1]+" file already exist.",7,"\<Overwrite;Overwrite\< All;\?\<Cancel;\<Ignore")
			DO CASE
				CASE pnExist = 1			&& Overwrite
					* do nothing	
				CASE pnExist = 2			&& Overwrite all
					plOverWall = .T.
				CASE pnExist = 3			&& Cancel
					plCancel = .T.
					EXIT
				CASE pnExist = 4			&& Ignore
					LOOP
			ENDCASE
		ENDIF
	ENDIF	
	
	*
	* Copy the file now.
	*
	pnErrNo = COPYFILE(ADDBS(JUSTPATH(m.CurDir))+pcDBFfiles[I,1],m.Dest+pcDBFfiles[I,1])
	
	*
	* Ask the user what action to take if 
	* an error occurs while copying
	*
	pnAction = 0
	IF NOT plIgnorAll
		IF pnErrNo > 0
			errmess = RETFERROR( pnErrNo )
			pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
			DO CASE
				CASE pnAction = 1			&& Cancel
					plCancel = .T.
					EXIT
				CASE pnAction = 2			&& Ignore
					LOOP
				CASE pnAction = 3			&& Ignore All
					plIgnorAll = .T.
			ENDCASE
		ENDIF	
	ENDIF
	= UPDTHERM(pnCurPercent,mess)

ENDFOR

IF NOT plCancel
	IF pnTotCDX > 0
		FOR I = 1 TO pnTotCDX

			mess = "Copying INDEXES : "+pcCDXfiles[I,1]+" TO "+m.Dest+pcCDXfiles[I,1]
			pnCurPercent = pnCurPercent + ((pcCDXfiles[I,2]/pnTotSize)*100)
	   	pnExist = 0
	
			IF NOT plOverWAll   
				IF FILE(m.Dest+pcCDXfiles[I,1])
					pnExist = DIALOG(pcCDXfiles[I,1]+" file already exist.",7,"\<Overwrite;Overwrite\< All;\?\<Cancel;\<Ignore")
					DO CASE
						CASE pnExist = 1			&& Overwrite
							* do nothing	
						CASE pnExist = 2			&& Overwrite all
							plOverWall = .T.
						CASE pnExist = 3			&& Cancel
							plCancel = .T.
							EXIT
						CASE pnExist = 4			&& Ignore
							LOOP
					ENDCASE
				ENDIF
			ENDIF	
	
			*
			* Copy the file now.
			*
			pnErrNo = COPYFILE(ADDBS(JUSTPATH(m.CurDir))+pcCDXfiles[I,1],m.Dest+pcCDXfiles[I,1])
	
			*
			* Ask the user what action to take if 
			* an error occurs while copying
			*
			pnAction = 0
			IF NOT plIgnorAll
				IF pnErrNo > 0
					errmess = RETFERROR( pnErrNo )
					pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
					DO CASE
						CASE pnAction = 1			&& Cancel
							plCancel = .T.
							EXIT
						CASE pnAction = 2			&& Ignore
							LOOP
						CASE pnAction = 3			&& Ignore All
							plIgnorAll = .T.
					ENDCASE
				ENDIF	
			ENDIF
			= UPDTHERM(pnCurPercent,mess)
		ENDFOR
	ENDIF
ENDIF	

IF NOT plCancel
	IF pnTotFPT > 0
		FOR I = 1 TO pnTotFPT

			mess = "Copying MEMO : "+pcFPTfiles[I,1]+" TO "+m.Dest+pcFPTfiles[I,1]
			pnCurPercent = pnCurPercent + ((pcFPTfiles[I,2]/pnTotSize)*100)
	   	pnExist = 0
	
			IF NOT plOverWAll   
				IF FILE(m.Dest+pcFPTfiles[I,1])
					pnExist = DIALOG(pcFPTfiles[I,1]+" file already exist.",7,"\<Overwrite;Overwrite\< All;\?\<Cancel;\<Ignore")
					DO CASE
						CASE pnExist = 1			&& Overwrite
							* do nothing	
						CASE pnExist = 2			&& Overwrite all
							plOverWall = .T.
						CASE pnExist = 3			&& Cancel
							EXIT
						CASE pnExist = 4			&& Ignore
							LOOP
						ENDCASE
				ENDIF
			ENDIF	
	
			*
			* Copy the file now.
			*
			pnErrNo = COPYFILE(ADDBS(JUSTPATH(m.CurDir))+pcFPTfiles[I,1],m.Dest+pcFPTfiles[I,1])
	
			*
			* Ask the user what action to take if 
			* an error occurs while copying
			*
			pnAction = 0
			IF NOT plIgnorAll
				IF pnErrNo > 0
					errmess = RETFERROR( pnErrNo )
					pnAction = DIALOG(errmess,7,"\?\<Cancel ;\<Ignore ;Ignore \<All")
					DO CASE
						CASE pnAction = 1			&& Cancel
							EXIT
						CASE pnAction = 2			&& Ignore
							LOOP
						CASE pnAction = 3			&& Ignore All
							plIgnorAll = .T.
					ENDCASE
				ENDIF	
			ENDIF
			= UPDTHERM(pnCurPercent,mess)

		ENDFOR
	ENDIF
ENDIF
	
= UPDTHERM(100,mess)
= DEACTTHERM()

IF NOT plCancel
	DO UPDATEFILE
ENDIF

*end
PROCEDURE UPDATEFILE
*begin
	IF USED('backup')
		SELECT backup
	ELSE	
		SELECT 0
		USE backup ORDER TAG "backtday"
	ENDIF	
	IF SEEK(PADR(m.BackType,10)+STR(m.BackDay))
		DO WHILE NOT RLOCK()
		ENDDO
		REPLACE backdate WITH DATE()
		UNLOCK IN backup
	ELSE
		DO WHILE NOT FLOCK()
		ENDDO
		APPEND BLANK
		REPLACE backtype WITH m.BackType
		REPLACE backday  WITH m.BackDay
		REPLACE backdate WITH DATE()
		UNLOCK IN backup
	ENDIF
*end
*!Ŀ
*!  FUNCTION/PROCEDURE NAME : _VWClose                        
*!                                                            
*!  FUNCTIONS : Terminate read if window isn't visible.       
*!
FUNCTION _VWClose
PARAMETER pcWindName
*begin
	PRIVATE pcWindName
	IF WVISIBLE(pcWindName)
		RETURN .F.
	ELSE
		RETURN .T.
	ENDIF
*end
